<!DOCTYPE html>
<title>Laporan Absen</title>
<div>
  <table>
    <tr>
      <td>Tahun</td>
      <td>:</td>
      <td>
        <select name="tahun" id="tahun">
          <option value="2019">2019</option>
          <option value="2018">2018</option>
          <option value="2017">2018</option>
        </select>
      </td>
    </tr>
    <tr>
      <td>Bulan</td>
      <td>:</td>
      <td>
        <select name="bulan" id="bulan">
          <option value="01">Januari</option>
          <option value="02">Februari</option>
          <option value="03">Maret</option>
          <option value="04">April</option>
          <option value="05">Mei</option>
          <option value="06">Juni</option>
          <option value="07">Juli</option>
          <option value="08">Agustus</option>
          <option value="09">September</option>
          <option value="10">Oktober</option>
          <option value="11">November</option>
          <option value="12">Desember</option>
        </select>
      </td>
    </tr>
    <tr>
      <td>Absensi</td>
      <td>:</td>
      <td>
        <select name="absensi" id="absensi"></select>
      </td>
    </tr>
  </table>
  <div>
    <button type="submit" onclick="tampilkanLaporan()">Submit</button>
  </div>
  <div id="laporan"></div>
</div>
<script>
  fetch('/absensi')
    .then(response =>  response.json())
    .then(value => {
      const selectAbsensi = document.querySelector('#absensi');

      value.forEach(absensi => {
        const {id, jenis, cabang, keterangan} = absensi;
        const {length} = selectAbsensi.options;
        selectAbsensi.options[length] = new Option(`${jenis} | ${cabang} (${keterangan})`, id);
      });
    })
  
  function tampilkanLaporan() {
    const selectTahun = document.querySelector('#tahun');
    const selectBulan = document.querySelector('#bulan');
    const selectAbsensi = document.querySelector('#absensi');

    const tahun = selectTahun.value;
    const bulan = selectBulan.value;
    const absensi = selectAbsensi.value;

    fetch(`/laporan?tahun=${tahun}&bulan=${bulan}&absensi=${absensi}`)
      .then(value => value.json())
      .then(laporan => {
        const jumlahHari = tanggalTerakhirDari(tahun, bulan);

        fetch(`/libur?tahun=${tahun}&bulan=${bulan}`)
          .then(value => value.json())
          .then(hariIstimewa => {
            buatTabelLaporan(laporan, jumlahHari, hariIstimewa);
          })
      })
  }

  function buatTabelLaporan(laporan, jumlahHari, hariIstimewa) {
    const tabelLaporan = document.createElement('table');
    const fieldLaporan = document.querySelector('#laporan');
    tabelLaporan.border = 1;

    const rangeTanggal = range(1, jumlahHari);

    tambahBaris(tabelLaporan, ['NIP', 'Nama', 'Jabatan', ...rangeTanggal], true);
    
    const dataLibur = hariIstimewa.map(libur => {
      libur.tanggal = new Date(libur.tanggal).getDate();
      return libur;
    })

    laporan.forEach(pegawai => {
      const {nip, nama, jabatan, data_absen} = pegawai;

      const dataAbsen = data_absen.map(absen => {
        const {tanggal, waktu, keterangan} = absen;

        const tanggalAbsen = new Date(absen.tanggal).getDate();
        const absensi = keterangan || waktu.slice(0, waktu.length - 3);

        return {
          tanggal: tanggalAbsen,
          absensi,
        };
      });

      const laporanAbsen = [...Array(jumlahHari)].map((_, index) => {
        const tanggal = index + 1;
        const hariLibur = dataLibur.find(libur => libur.tanggal === tanggal);

        if (hariLibur) {
          return hariLibur.keterangan;
        }

        const absenDitemukan = dataAbsen.find(absen => absen.tanggal === tanggal);

        if (absenDitemukan) {
          return absenDitemukan.absensi;
        } else {
          return '';
        }
      });

      tambahBaris(tabelLaporan, [nip || '', nama, jabatan, ...laporanAbsen]);
    });

    while (fieldLaporan.lastChild) {
      fieldLaporan.removeChild(fieldLaporan.lastChild);
    }

    fieldLaporan.append(tabelLaporan);
  }

  function tambahBaris(tabel, data, kepala=false) {
    const body = document.createElement('tbody');
    const baris = document.createElement('tr');
    tabel.append(body);
    body.append(baris);

    data.forEach(text => {
      const kolom = document.createElement(kepala ? 'th' : 'td');
      kolom.append(text);
      baris.append(kolom);
    })
  }
  
  function range(from, end) {
    return [...Array(end).keys()].map(i => i + from);
  }

  function tanggalTerakhirDari(tahun, bulan) {
    return new Date(tahun, bulan, 0).getDate();
  }
</script>